<?php
/*
Plugin Name: wpFutureCal
Plugin URI: http://www.timlinden.com/blog/
Description: Instantly see future scheduled posts in a calendar
Version: 1.0
Author: Tim Linden
Author URI: http://www.timlinden.com
*/


function wpFutureCal_meta() {
		global $wpdb;

		?>
		<style>
.good { background-color: #7BC67F; }
.good A { color: black; }
.bad  { background-color: #C93434; }
.calendar { width: 100%; }
.calendar td {  color: #000000;
    font-size: 8px;
    font-weight: bold;
    height: 12px;
    text-align: center;
    width: 14%; 
    border: 1px solid; }
.calendar-month { background-color: #00345b; color: white; }
.calendar th { color: black; background-color: #C4CAD0; text-align: center; border: 1px solid; font-size: 8px;  }
		</style>
		<?php 
	
		$month = date("m");
		$year = date("Y");
	
		$query = "SELECT DATE( post_date ), ID, post_title FROM {$wpdb->posts} WHERE YEAR( post_date ) = '$year' AND MONTH( post_date ) = '$month' AND post_type = 'post'";
		$result = mysql_query($query);
		$cnt = mysql_num_rows($result);
		
		for ($i=0; $i<$cnt; $i++) {
			$row = mysql_fetch_row($result);
			$days[$row[0]] = array(1, $row[1], $row[2]);
		}
		
		echo wpFutureCal_generate_calendar($year, $month, $days);
	
		$nexttime = strtotime("next month");
		$month = date("m", $nexttime);
		$year = date("Y", $nexttime);
	
		$query = "SELECT DATE( post_date ), ID, post_title FROM {$wpdb->posts} WHERE YEAR( post_date ) = '$year' AND MONTH( post_date ) = '$month' AND post_type = 'post'";
		$result = mysql_query($query);
		$cnt = mysql_num_rows($result);
		
		for ($i=0; $i<$cnt; $i++) {
			$row = mysql_fetch_row($result);
			$days[$row[0]] = array(1, $row[1], $row[2]);
		}
		
		echo wpFutureCal_generate_calendar($year, $month, $days);
}


function wpFutureCal_setup() {
	add_meta_box('wpFutureCal_meta', 'wpFutureCal', "wpFutureCal_meta", "post", "side", "high");
}

add_action('admin_menu', 'wpFutureCal_setup');


function wpFutureCal_generate_calendar($year, $month, $days = array(), $show = 0){
	$today = date("Y-m-d");
	
	$day_name_length = 3;
	$month_href = NULL;
	$first_day = 0;
	$pn = array();
	
	$first_of_month = gmmktime(0,0,0,$month,1,$year);
	#remember that mktime will automatically correct if invalid dates are entered
	# for instance, mktime(0,0,0,12,32,1997) will be the date for Jan 1, 1998
	# this provides a built in "rounding" feature to generate_calendar()

	$day_names = array(); #generate all the day names according to the current locale
	for($n=0,$t=(3+$first_day)*86400; $n<7; $n++,$t+=86400) #January 4, 1970 was a Sunday
		$day_names[$n] = ucfirst(gmstrftime('%A',$t)); #%A means full textual day name

	list($month, $year, $month_name, $weekday) = explode(',',gmstrftime('%m,%Y,%B,%w',$first_of_month));
	$weekday = ($weekday + 7 - $first_day) % 7; #adjust for $first_day
	$title   = htmlentities(ucfirst($month_name)).'&nbsp;'.$year;  #note that some locales don't capitalize month and day names

	#Begin calendar. Uses a real <caption>. See http://diveintomark.org/archives/2002/07/03
	@list($p, $pl) = each($pn); @list($n, $nl) = each($pn); #previous and next links, if applicable
	if($p) $p = '<span class="calendar-prev">'.($pl ? '<a href="'.htmlspecialchars($pl).'">'.$p.'</a>' : $p).'</span>&nbsp;';
	if($n) $n = '&nbsp;<span class="calendar-next">'.($nl ? '<a href="'.htmlspecialchars($nl).'">'.$n.'</a>' : $n).'</span>';
	$calendar = '<table class="calendar" cellspacing=1>'."\n".
		'<caption class="calendar-month">'.$p.($month_href ? '<a href="'.htmlspecialchars($month_href).'">'.$title.'</a>' : $title).$n."</caption>\n<tr>";

	if($day_name_length){ #if the day names should be shown ($day_name_length > 0)
		#if day_name_length is >3, the full name of the day will be printed
		foreach($day_names as $d)
			$calendar .= '<th abbr="'.htmlentities($d).'">'.htmlentities($day_name_length < 4 ? substr($d,0,$day_name_length) : $d).'</th>';
		$calendar .= "</tr>\n<tr>";
	}

	if($weekday > 0) $calendar .= '<td colspan="'.$weekday.'">&nbsp;</td>'; #initial 'empty' days
	for($day=1,$days_in_month=gmdate('t',$first_of_month); $day<=$days_in_month; $day++,$weekday++){
		if($weekday == 7){
			$weekday   = 0; #start a new week
			$calendar .= "</tr>\n<tr>";
		}
		$date = $year . "-" . str_pad($month, 2, "0", STR_PAD_LEFT) . "-" . str_pad($day, 2, "0", STR_PAD_LEFT);
		if ($show == 0) {
			if ($days[$date][0] == 1) {
				$calendar .= "<td class='good'><a href='".get_edit_post_link($days[$date][1])."' title='".htmlspecialchars($days[$date][2], ENT_QUOTES)."'>$day</a></td>";
			} elseif ($days[$date][0] == 2) {
				$calendar .= "<td>$day</td>";
			} else {
				$calendar .= "<td class='bad'>$day</td>";
			}
		} else {
			$calendar .= "<td>".number_format($days[$date], 0)."</td>";
		}
	}
	if($weekday != 7) $calendar .= '<td colspan="'.(7-$weekday).'">&nbsp;</td>'; #remaining "empty" days

	return $calendar."</tr>\n</table>\n";
}

?>